public class Copy implements Cloneable {
    private int i;
    public Copy(int i) {
        this.i = i;
    }
    public void inc() {
        i++;
    }
    public String toString() {
        return "Copy(i="+i+")";
    }
    public Object clone() {
        try {
	    // Object.clone() erzeugt byteweise Kopie
	    // mit demselben dynamischen Typ (hier Copy):
	    Copy c = (Copy) super.clone();
	    // ... das reicht hier aus
	    // (andernfalls muesste man hier noch weiter
	    // kopieren - "von Hand").
	    return c;
        }
	catch (CloneNotSupportedException e) {
	    // Transformation in eine ungepruefte Ausnahme
	    throw new RuntimeException("Unexpected exception: "+e);
	}
    }

    public static void change(Copy c) {
        c.inc();
    }

    public static void main(String[] args) {
        Copy c = new Copy(1);
	System.out.println(""+c);
	change(c);			// Objekt uebergeben => wird veraendert!
	System.out.println(""+c);
	change((Copy) c.clone());	// Kopie uebergeben => nur Kopie geaendert!
	System.out.println(""+c);
    }
}
