public class Complex {
    private int re, im;
    public Complex(int re, int im) {
        this.re = re;
	this.im = im;
    }
    public Complex(int re) {
	this(re, 0);
    }
    public String toString() {
        return re+" + "+im+" i";
    }
    public boolean equals(Object o) {
        if (o instanceof Complex) {
	    Complex c = (Complex) o;
	    return re == c.re && im == c.im;
	}
	else
	    return false;
    }

    public int hashCode() {
        int res = 17;
	res += res * 37 + re;
	res += res * 37 + im;
	return res;
    }

    public static void main(String[] args) {
        Complex c1 = new Complex(3, 0);
	Complex c2 = new Complex(3, 0);

	System.out.println("c1 = "+c1);
	System.out.println("c2 = "+c2);

	System.out.println("c1 == c2:      "+(c1 == c2));
	System.out.println("c1.equals(c2): "+c1.equals(c2));

	System.out.println("Hashcode von c1: "+c1.hashCode());
	System.out.println("Hashcode von c2: "+c2.hashCode());
    }
}
